﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DisableButtonsInOptionSet92477
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.Load += new EventHandler(Form1_Load);
            this.ultraOptionSet1.ValueChanged += new EventHandler(ultraOptionSet1_ValueChanged);
        }

        //Create a variable to store the selected item's index
        int oldIndex = -1;
        delegate void MyCallBack();

        void ultraOptionSet1_ValueChanged(object sender, EventArgs e)
        {
            //Set some condtion to check for items which are intended to be disabled; in this case, the item is checked to ensure that it is not null and then
            //again checked to ensure that its alpha level has been modified, anything deviating from the default value will satisfy this condition
            if (ultraOptionSet1.CheckedItem != null && ultraOptionSet1.Items[ultraOptionSet1.CheckedIndex].Appearance.AlphaLevel != 0)
            {
                //Maintain selection of the previous item
                ultraOptionSet1.CheckedIndex = oldIndex;
            }
            else 
            {
                //Allow selection of the current item
                oldIndex = ultraOptionSet1.CheckedIndex;
            }

            ultraOptionSet1.BeginInvoke(new MyCallBack(this.MyCallbackHandler));
        }

        void Form1_Load(object sender, EventArgs e)
        {
            //Populate the OptionSet with sample items
            for (int i = 0; i < 9; i++)
            {
                ultraOptionSet1.Items.Add("item:" + i.ToString());
            }

            //Set the desired alphaLevel to give the item a grayed out appearance
            //Note that 1 is maximum transparency;  0 is the default opacity and 255 is full opacity
            ultraOptionSet1.Items[2].Appearance.AlphaLevel = 85;

            ultraOptionSet1.CheckedIndex = -1;
            ultraOptionSet1.FocusedIndex = -1;
        }

        //Prevent the item from being selected
        void MyCallbackHandler()
        {
            ultraOptionSet1.FocusedIndex = ultraOptionSet1.CheckedIndex;
        }

    }
}
